/* Problem URL: https://codeforces.com/problemset/problem/2041/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    int n, m;
    cin >> n >> m;

    V<string> a(n);
    cin >> a;

    vvvvi dis(n, vvvi(m, vvi(4, vi(4, oo))));
    auto find_s = [&]() -> pair<pair<int, int>, pair<int, int>> {
        int si;
        int sj;
        int ei;
        int ej;
        rep(i, n) {
            rep(j, m) {
                if (a[i][j] == 'S') {
                    si = i;
                    sj = j;
                    continue;
                }

                if (a[i][j] == 'T') {
                    ei = i;
                    ej = j;
                }
            }
        }

        return {{si, sj}, {ei, ej}};
    };

    auto [s, t] = find_s();
    auto [si, sj] = s;
    auto [ei, ej] = t;

    queue<tuple<int, int, int, int>> q;
    dis[si][sj][0][0] = 0;
    dis[si][sj][1][0] = 0;
    dis[si][sj][2][0] = 0;
    dis[si][sj][3][0] = 0;
    q.emplace(si, sj, 0, 0);
    q.emplace(si, sj, 1, 0);
    q.emplace(si, sj, 2, 0);
    q.emplace(si, sj, 3, 0);
    int ans = oo;
    while (!q.empty()) {
        auto [i, j, d, t] = q.front();
        q.pop();

        if (i == ei && j == ej) {
            rmin(ans, dis[i][j][d][t]);
        }

        int add[][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
        rep(k, 4) {
            int id = i + add[k][0];
            int jd = j + add[k][1];

            int td = k == d ? t + 1 : 1;

            if (a[id][jd] == '#' || td > 3 || dis[id][jd][k][td] <= dis[i][j][d][t] + 1) {
                continue;
            }

            dis[id][jd][k][td] = dis[i][j][d][t] + 1;
            q.emplace(id, jd, k, td);
        }
    }

    cout << (ans == oo ? -1 : ans) << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
